package org.apache.maven.deploy.deployers;

/* ====================================================================
 * The Apache Software License, Version 1.1
 *
 * Copyright (c) 2001 The Apache Software Foundation.  All rights
 * reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by the
 *        Apache Software Foundation (http://www.apache.org/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "Apache" and "Apache Software Foundation" and
 *    "Apache MavenSession" must not be used to endorse or promote products
 *    derived from this software without prior written permission. For
 *    written permission, please contact apache@apache.org.
 *
 * 5. Products derived from this software may not be called "Apache",
 *    "Apache MavenSession", nor may "Apache" appear in their name, without
 *    prior written permission of the Apache Software Foundation.
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by many
 * individuals on behalf of the Apache Software Foundation.  For more
 * information on the Apache Software Foundation, please see
 * <http://www.apache.org/>.
 *
 * ====================================================================
 */

import org.apache.commons.lang.StringUtils;
import org.apache.maven.deploy.RepositoryInfo;
import org.apache.maven.deploy.DeployRequest;
import org.apache.maven.deploy.exceptions.AuthenticationException;
import org.apache.maven.deploy.exceptions.TransferFailedException;

import com.jcraft.jsch.ChannelSftp;
import com.jcraft.jsch.SftpATTRS;
import com.jcraft.jsch.SftpException;
import com.jcraft.jsch.SftpProgressMonitor;

/**
 * An SSH2/SFTP deployer 
 * 
 * @author Michal Maczka
 * @version $Revision: 1.8 $ $Date: 2003/08/19 04:45:05 $
 */
public class SFtpDeployer extends GenericSshDeployer
{
    /**Protocol understood by by this deployer*/
    public final static String PROTOCOL = "sftp://";

    /** SSH2 Chanel names used to communicate with the server*/
    private final static String SFTP_CHANNEL = "sftp";

    /** artibute of file used in SSH which denotes is given file is a directory*/
    private static final int S_IFDIR = 0x4000;

    private ChannelSftp channel = null;

    private Integer groupId = null;

    /* (non-Javadoc)
     * @see org.apache.maven.deploy.deployers.Deployer#init(org.apache.maven.deploy.HostInfo)
     */
    public void init(RepositoryInfo repoInfo)
        throws AuthenticationException
    {

        try
        {
            if (repoInfo.getGroup() != null)
            {
                groupId = Integer.getInteger(repoInfo.getGroup());
            }
        }
        catch (NumberFormatException e)
        {
            throw new AuthenticationException("SFTP deployer: remote group should be an integer");
        }
        super.init(repoInfo);

        channel = null;
        try
        {
            channel = (ChannelSftp) getSession().openChannel(SFTP_CHANNEL);
            channel.connect();
            channel.cd(repoInfo.getBasedir());
        }
        catch (Exception e)
        {
            throw new AuthenticationException(e.getMessage());
        }

    }

    /**
     * @see org.apache.maven.deploy.deployers.Deployer#release()
     */
    public void release()
    {
        channel.disconnect();
        super.release();
    }

    /**
     * @see Deployer#deploy(DeployRequest)
     */
    public void deploy(DeployRequest request) throws TransferFailedException
    {
        try
        {

            // iterate over all directories in the path. try to create
            // directory 
            String[] dirs = StringUtils.split(request.dirname(), "/");
            for (int i = 0; i < dirs.length; i++)
            {
                try
                {
                    SftpATTRS attrs = channel.stat(dirs[i]);
                    if ((attrs.getPermissions() & S_IFDIR) != 0)
                    {
                        // file exists and is dierctory                        
                        channel.cd(dirs[i]);
                    }
                    else
                    {
                        throw new TransferFailedException(
                            "Incorrect remote path:" + request.getDestFile());
                    }
                }
                catch (Exception e)
                {
                    // file most probably does not exists
                    channel.mkdir(dirs[i]);
                    channel.cd(dirs[i]);
                }

            }
            if (getRepositoryInfo().isDebugOn())
            {
                channel.put(
                    request.getSrcFile(),
                    request.filename(),
                    new ProgressMonitor());
            }
            else
            {

                channel.put(request.getSrcFile(), request.filename());

            }

            if (groupId != null)
            {
                if (getRepositoryInfo().isDebugOn())
                {
                    System.out.println("Changing group to: " + groupId);
                }
                channel.chgrp(groupId.intValue(), request.getDestFile());
                if (getRepositoryInfo().isDebugOn())
                {
                    System.out.println("Group successfully changed");
                }

            }
            // change back the working directory to repository root
            for (int i = 0; i < dirs.length; i++)
            {
                channel.cd("..");
            }
        }
        catch (SftpException e)
        {

            String msg =
                "Error occured while deploying to remote host:"
                    + getRepositoryInfo().getHost()
                    + ":"
                    + e.getMessage();
            throw new TransferFailedException(msg, e);
        }

    }

    class ProgressMonitor implements SftpProgressMonitor
    {

        public boolean count(long count)
        {
            System.out.print("#");
            return true;
        }

        public void end()
        {
            System.out.println();

        }

        public void init(int op, String src, String dest, long max)
        {

        }

    }

}
